% TTGETX   Get a specific task attribute.
%
%  ttGetX refers to the collection of functions used to retrieve
%  various task attributes. There exist functions for the following
%  attributes:
%
%     relative deadline          - ttGetDeadline
%     worst-case execution time  - ttGetWCET
%     priority                   - ttGetPriority
%     period                     - ttGetPeriod
%
%     release time               - ttGetRelease
%     absolute deadline          - ttGetAbsDeadline
%     execution time budget      - ttGetBudget
%
%  Use the true function names for help on the individual functions.
%
% See also TTSETX

% Copyright (c) 2016 Lund University
%
% Written by Anton Cervin, Dan Henriksson and Martin Ohlin,
% Department of Automatic Control LTH, Lund University, Sweden.
%   
% This file is part of TrueTime 2.0.
%
% TrueTime 2.0 is free software: you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation, either version 3 of the
% License, or (at your option) any later version.
%
% TrueTime 2.0 is distributed in the hope that it will be useful, but
% without any warranty; without even the implied warranty of
% merchantability or fitness for a particular purpose. See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with TrueTime 2.0. If not, see <http://www.gnu.org/licenses/>
